//decode.c source code debugged and compiled by parallax.

#include <stdio.h>
#include <string.h>

void decode(char* data, int len)
{

  int i;

  for (i = 0; i < len; i++) {

    if ( data[i] >= 'a') {

      data[i] = data[i] - ('.' + 13);

    } else if ( data[i] >= 'A') {

      data[i] = data[i] - ('.' + 7);

    } else if (data[i] >= '.') {

      data[i] -= '.';

    }

  }

}


unsigned long int getValue(char* data, int start, int end)
{
  unsigned long int val = 0;

  int index = start / 6;

  int numBits = (end - start) + 1;

  int offset, i;

  offset = 5-(start % 6);

  for (i = 0; i < numBits; i++) {

    val >>= 1;

    if ((1 << offset) & data[index]) {

      val = val | (1L << (numBits-1));

    } else {


    }

    offset--;

    if (offset == -1) {

      index++;

      offset = 5;

    }

  }

  return val;
}

void printBin(char* data, int length, int bitsPerByte)
{

  int i, j;

  for (j=0; j<length; j++) {

    for (i=bitsPerByte-1; i>=0; i--) {

      if (*data & (1 << i)) {

 printf("1");

      } else {

 printf("0");

      }

    }

    printf(" ");

    data++;
  }

  printf("\n");

}

unsigned char revBits(unsigned char datum, int bitsPerByte)
{

  unsigned char rev = 0;

  int i = 0;

  for (i = 0; i < bitsPerByte; i++) {

    rev <<= 1;

    if ( (1 << i) & datum ) {

      rev = rev | ( 1 << i );

    }

  }

  return rev;

}

int calcCheck(unsigned char* data, int len, int reverse, int bitsPerByte)
{

  int i;

  unsigned long int val = 0;

  for (i = 0; i < len; i++) {

    if (reverse) {

      val ^= revBits(data[i], bitsPerByte);

    } else {

      val ^= data[i];

    }

  }

  return val;

}

int checkText(char* buff, int len)
{
  int i;

  long int checkSum = getValue(buff, ( len - 3 ) * 6, len * 6 - 1);

  long int value = getValue(buff, 0, 3) + getValue(buff, 4, 11);

  for (i = 2; i < len - 3; i++) {

    value += buff[i];

  }

  printf("checkSum:%d value:%d\n", checkSum, value);

  return (value == checkSum);

}

void formatText(char* inText, int len, char* outText)
{
  int i;
  int count;
  int spaceFlag = 0;
  int ignoreNext = 0;

  for (i = 0; i < len; i++) {

    if (ignoreNext) {

      ignoreNext = 0;
      count++;
      continue;

    }

    if ((count == 19) && (i < len - 1)) {

      printf("[%c] [%c]\n", inText[i], inText[i+1]);

      if (inText[i] == '-') {

 // ignore hyphen at screen row boundary

      } else if ((inText[i] != ' ') && (inText[i+1] != ' ')) {

 *outText++ = inText[i];
 *outText++ = ' ';

      } else {

 *outText++ = inText[i];

      }

      count = 0;

    } else {

      if (inText[i] == ' ') {

 if (spaceFlag) {

   // ignore multiple spaces

 } else {

   *outText++ = ' ';

   spaceFlag = 1;

 }

      } else {

 spaceFlag = 0;

 *outText++ = inText[i];

 if (inText[i] == '.' || inText[i] == ',' ) {

   *outText++ = ' ';
   spaceFlag = 1;

 }

      }

    }

    count++;

  }

  *outText = '\0';

}

#define ARROW_1      0x00
#define M25_INFO_1   0x01
#define M25_INFO_2   0x02
#define M25_INFO_3   0x03
#define M25_INFO_4   0x04
#define TEXT_MESSAGE 0x06
#define ARROW_2      0x08
#define ARROW_3      0x09
#define TRAFFIC_INFO 0x0a
#define TIME_SYNC    0x0b

int main()
{

  char buff[255];
  char text[255];

  int i;

  long int checkSum, checkVal;

  int speed, dirn, posn;

  int page;

  int square;

  int area;

  int count;

  int len, lenBits,type, bitsLeft, offset;

  int mins, hours, days;

  unsigned long int val;

// added by parallax
  printf("type raw data here then press enter:\n");
// end parallax
			
  while (1) {

    checkVal = 0;

    gets(buff);

    len = strlen(buff);

    bitsLeft = len * 6;

    decode(buff, 1);

    type = getValue(buff, 0, 3);

    switch (type) {

    case ARROW_1:
    case ARROW_2:
    case ARROW_3:
      decode(&buff[1], len-1);
      printf("Message type: Arrow\n");
      offset = 4;
      bitsLeft -=4;
      while (bitsLeft >= 14+16) {
 posn = getValue(buff, offset, offset+9);
 printf("Position:%03x ", posn );
 speed = getValue(buff, offset+10, offset+12);
 printf("Speed:%d ", speed * 5 );
 dirn = getValue(buff, offset+13, offset+13);
 printf("Dirn:%d\n", dirn );
 bitsLeft-=14;
 offset += 14;
 checkVal += posn + speed + dirn;
      }
      checkSum = getValue(buff, offset, len * 6 - 1);
      printf("checksum:%ld checkval:%ld\n", checkSum, checkVal);
      break;


    case M25_INFO_1:
    case M25_INFO_2:
    case M25_INFO_3:
    case M25_INFO_4:
    case TRAFFIC_INFO:
      printf("Message type: Traffic Info\n");

      if (type == TRAFFIC_INFO) {
 decode(&buff[1], 1);
 square = getValue(buff, 4, 11);
 checkVal += type + square;
 i = 2;
      } else {
 square = type;
 checkVal += type;
 i = 1;
      }
      printf("Square: %02x\n", square);
      printf("Msg: ");
      for (; i < len - 3; i++) {
 printf("%c", buff[i]);
 checkVal += buff[i];
      }
      printf("\n");

      decode(&buff[i], 3);

      checkSum = getValue(buff, i * 6, len * 6 - 1);

      printf("checksum:%ld checkval:%ld\n", checkSum, checkVal);

      break;

    case TEXT_MESSAGE:
      printf("Message type: Text Message\n");
      decode(&buff[1], 1);
      page = getValue(buff, 4, 11);
      printf("page: %d\n", page);
      checkVal += type + page;
      printf("Msg: ");
      for (i = 2; i < len - 3; i++) {
 printf("%c", buff[i]);
 checkVal += buff[i];
      }
      formatText(&buff[2], len-5, text);
      printf("\n");
      printf("Formatted: %s\n", text);

      decode(&buff[i], 3);

      checkSum = getValue(buff, i * 6, len * 6 - 1);

      printf("checksum:%ld checkval:%ld\n", checkSum, checkVal);

      break;

    case TIME_SYNC:
      decode(&buff[1], len-1);

      val = getValue(buff, 4, 27);

      checkVal = type + getValue(buff, 4, 19)
                      + getValue(buff, 20, 23)
                      + getValue(buff, 24, 33)
                      + getValue(buff, 34, 39);

      printf("Message type: Time Sync\n");

      printf("Total minutes: %ld\n", val);

      mins = val % 60;

      hours = (val / 60) % 24;

      days = (val / (60 * 24)) - 365 - 366 + 1;//% 365;

      printf("Time: %d %02d:%02d\n", days, hours, mins);

      offset = 4 + 20 + 16;

   lenBits = len * 6;

      while (offset < lenBits - (14 + 16))


        area = getValue(buff, offset, offset + 5);

        offset += 6;

        count = getValue(buff, offset, offset + 1);

        offset += 2;

        offset += 5; // ignore 0s, should this be included in count?

  checkVal += area + count;

        for ( i = 0; i < count; i++) {

          posn  = getValue(buff, offset,    offset+9);
          speed = getValue(buff, offset+10, offset+12);
          dirn  = getValue(buff, offset+13, offset+13);

          printf("Area:%02x Position:%03x Speed:%d Dirn:%d\n",
                 area, posn, speed*5, dirn);

          offset += 14;

          checkVal += posn + speed + dirn;

        }

//      } test1

      checkSum = getValue(buff, offset, lenBits - 1);

      printf("checksum:%ld checkval:%ld\n", checkSum, checkVal);

      break;

    default:
      printf("Error: unknown message type %d\n", type);
      break;

    }

    printBin(buff, len, 6);


	return 0;
    }

//  return 0; moved up 3 lines

 }